package GererPretSA;
import java.sql.*;
// La classe CourtierBDExemplaire est un intermdaire qui encapsule les interactions avec la BD
public class CourtierBDExemplaire {
    private Connection uneConnection;
   
    // Constructeur pour connexion passe par le crateur
    public CourtierBDExemplaire(Connection laConnection){
        this.uneConnection = laConnection;
    }
    
    public void setConnection(Connection laConnection){
        this.uneConnection = laConnection;
    }

    public Exemplaire chercherExemplaireParIdExemplaire(String idExemplaire)
    // Ne considre pas les rfrences au Livre et aux Prets
        throws Exception {
        // Verrouillage de l'exemplaire (FOR UPDATE)pour serialisabilite 
        // (Oracle mode READ COMMITTED)
        PreparedStatement unEnonceSQL = uneConnection.prepareStatement
        ("SELECT statut FROM Exemplaire WHERE idExemplaire = ? FOR UPDATE");
        unEnonceSQL.setString(1,idExemplaire);
        ResultSet resultatSelect = unEnonceSQL.executeQuery();
        if (resultatSelect.next()){
            Exemplaire unExemplaire = 
                new Exemplaire(
                    idExemplaire,
                    resultatSelect.getString("statut"));
            unEnonceSQL.close();
            return unExemplaire;
        }else{
            unEnonceSQL.close();
            throw new Exception("Exemplaire inexistant");
        }
    }
}